#include "HookDrv.h"
#include "sync.h"
#include "Lists.h"
#include "ps.h"

extern DWORD g_PidTobeProtct;
extern  OFFSETS g_Offsets;

KPH_GUARDED_LOCK SsLock;
static FAST_MUTEX SsMutex;

int WriteUserMode( void * address, DWORD size, void * data )
{
	NTSTATUS Status;
	PMDL mdl;
	PMDL mdl_src;
	int returnf;

	returnf = -1;

	if ( MmIsAddressValid( data ) && MmIsAddressValid( address ) )
	{
		mdl_src = IoAllocateMdl( data, size,  FALSE, FALSE, NULL );
		if ( mdl_src )
		{
			returnf = 0;
			__try 
			{     
				MmProbeAndLockPages( mdl_src, KernelMode, IoReadAccess );
			}
			__except(EXCEPTION_EXECUTE_HANDLER) 
			{
				goto out_first;
			}

			data = MmGetSystemAddressForMdlSafe( mdl_src, NormalPagePriority );

			if ( data )
			{
				mdl = IoAllocateMdl( address, size,  FALSE, FALSE, NULL );
				if( mdl )
				{         
					__try 
					{     
						MmProbeAndLockPages( mdl, UserMode, IoWriteAccess );
					}
					__except(EXCEPTION_EXECUTE_HANDLER) 
					{
						goto out_second;
					}

					address = MmGetSystemAddressForMdlSafe( mdl, NormalPagePriority );

					if( address ) 
					{
						returnf = 0;
						__try 
						{     
							memcpy( address, data, size );
						}
						__except(EXCEPTION_EXECUTE_HANDLER) 
						{
							goto out_three;
						}
					}

out_three:
					MmUnlockPages( mdl );

out_second:
					IoFreeMdl( mdl );  
				}
			}

			MmUnlockPages( mdl_src );
out_first:
			IoFreeMdl( mdl_src );
		}
	}

	return returnf;
}

//
//   32-bit thunking ṹ
//

typedef struct _ARKDATACOUNT_32 {
	DWORD servicePid;
	PVOID serviceBaseAddr;
	UINT dataCount;
} ARKDATACOUNT32, *PARKDATACOUNT32;

typedef struct READ_KERN_MEM_s32
{
	UINT32            src_address;
	DWORD            size;
	MEM_SYM_TYP_t    type;
	UINT32            dst_address;
	ULONGLONG		ll_address;
	UINT32            other_info;
	DWORD			pid;	//ҪPid
	PARKDATACOUNT32    process_count;
	OFFSETS			offset;
} READ_KERN_MEM_t32;



NTSTATUS FLDispatchDeviceControl(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp)
{
	NTSTATUS status;// = STATUS_SUCCESS;
	READ_KERN_MEM_t      read_kern_mem;
	void               * ptrdat;
	PEPROCESS eprocess;
	KAPC_STATE apcState ;//= {0};
	KPROCESSOR_MODE accessMode;

	HANDLE ph;
	OBJECT_ATTRIBUTES    attr;   
	CLIENT_ID    cid;  
	PIO_STACK_LOCATION irpSp;
	
	PARKDATACOUNT pDataCount;
	PARKDATACOUNT32 pDataCount32;

	READ_KERN_MEM_t32 read_kern_mem32;

	PSIZE_T NumberOfBytesRead;
	PFLPROCESS pArkProcData;
	DWORD dwOutBuffSize;// = 0;
	UINT nIndex;// = 0;

	NumberOfBytesRead = NULL;
	dwOutBuffSize = 0;
	nIndex = 0;
	accessMode = Irp->RequestorMode;
	ptrdat = NULL;

#if defined(_WIN64)
	//buffer 32λ thunk it into 64-bit
	if( IoIs32bitProcess(Irp))
	{
	//	READ_KERN_MEM_t32 read_kern_mem32;
		read_kern_mem32 = * ( (READ_KERN_MEM_t32 *) Irp->AssociatedIrp.SystemBuffer );
		if( read_kern_mem32.type == SYM_TYP_GET_DATA)
		{
			pDataCount32 = read_kern_mem32.process_count;
			if( MmIsAddressValid(pDataCount32))
			{
				dprintf("SYM_TYP_GET_DATA get it!");
				pDataCount32->dataCount = ScanAndGetProcessCount();
				pDataCount32->servicePid = GetServicesPid();
				pDataCount32->serviceBaseAddr = GetServicesBaseAddress(pDataCount32->servicePid);//64λֵַ32λ
			}
		}
		else if( read_kern_mem32.type == SYM_TYP_READWITHSTACKATTACH)
		{
			attr.Length = sizeof(OBJECT_ATTRIBUTES);   
			attr.RootDirectory = 0;   
			attr.ObjectName = 0;   
			attr.Attributes = 0;   
			attr.SecurityDescriptor = 0;   
			attr.SecurityQualityOfService = 0;   

			cid.UniqueProcess = (HANDLE)read_kern_mem32.pid;   
			cid.UniqueThread = 0;   
			ZwOpenProcess(&ph, PROCESS_ALL_ACCESS, &attr, &cid);   

			status = KpiReadVirtualMemory(ph,
				read_kern_mem32.ll_address,
				read_kern_mem32.dst_address,
				read_kern_mem32.size,
				NumberOfBytesRead,
				accessMode);

		}
		else if( read_kern_mem32.type == SYM_TYP_WRITEUSERMEM)
		{
			attr.Length = sizeof(OBJECT_ATTRIBUTES);   
			attr.RootDirectory = 0;   
			attr.ObjectName = 0;   
			attr.Attributes = 0;   
			attr.SecurityDescriptor = 0;   
			attr.SecurityQualityOfService = 0;   

			cid.UniqueProcess = (HANDLE)read_kern_mem32.pid;   
			cid.UniqueThread = 0;   
			ZwOpenProcess(&ph, PROCESS_ALL_ACCESS, &attr, &cid);   

			status = KpiWriteVirtualMemory(ph,
				read_kern_mem32.ll_address,
				read_kern_mem32.src_address,
				read_kern_mem32.size,
				NumberOfBytesRead,
				accessMode);

		}
		dprintf("Is32bitProcess\n");

		Irp->IoStatus.Status = STATUS_SUCCESS;
		status = Irp->IoStatus.Status;

		IoCompleteRequest(Irp, IO_NO_INCREMENT);
		return status;
	}
	else
	{
		dprintf("NOT Is32bitProcess\n");
	}
#endif

	
	read_kern_mem32 = * ( (READ_KERN_MEM_t32 *) Irp->AssociatedIrp.SystemBuffer );
	if( read_kern_mem32.type == SYM_TYP_GET_DATA)
	{
		pDataCount32 = read_kern_mem32.process_count;
		if( MmIsAddressValid(pDataCount32))
		{
			dprintf("SYM_TYP_GET_DATA get it!");
			pDataCount32->dataCount = ScanAndGetProcessCount();
			pDataCount32->servicePid = GetServicesPid();
			pDataCount32->serviceBaseAddr = GetServicesBaseAddress(pDataCount32->servicePid);//64λֵַ32λ
		}
	}
	else if( read_kern_mem32.type == SYM_TYP_NULL)
	{
		//ں˿ռڴ
		ptrdat = read_kern_mem32.src_address;
	}
	else if( read_kern_mem32.type == SYM_TYP_READWITHSTACKATTACH)
	{
		attr.Length = sizeof(OBJECT_ATTRIBUTES);   
		attr.RootDirectory = 0;   
		attr.ObjectName = 0;   
		attr.Attributes = 0;   
		attr.SecurityDescriptor = 0;   
		attr.SecurityQualityOfService = 0;   

		cid.UniqueProcess = (HANDLE)read_kern_mem32.pid;   
		cid.UniqueThread = 0;   
		ZwOpenProcess(&ph, PROCESS_ALL_ACCESS, &attr, &cid);   

		status = KpiReadVirtualMemory(ph,
			read_kern_mem32.src_address,
			read_kern_mem32.dst_address,
			read_kern_mem32.size,
			NumberOfBytesRead,
			accessMode);

	}
	else if( read_kern_mem32.type == SYM_TYP_WRITEUSERMEM)
	{
		attr.Length = sizeof(OBJECT_ATTRIBUTES);   
		attr.RootDirectory = 0;   
		attr.ObjectName = 0;   
		attr.Attributes = 0;   
		attr.SecurityDescriptor = 0;   
		attr.SecurityQualityOfService = 0;   

		cid.UniqueProcess = (HANDLE)read_kern_mem32.pid;   
		cid.UniqueThread = 0;   
		ZwOpenProcess(&ph, PROCESS_ALL_ACCESS, &attr, &cid);   

		status = KpiWriteVirtualMemory(ph,
			read_kern_mem32.dst_address,
			read_kern_mem32.src_address,
			read_kern_mem32.size,
			NumberOfBytesRead,
			accessMode);

	}
	else if(read_kern_mem32.type == SYM_TYP_HOOK_OBR)
	{
		ptrdat = ObReferenceObjectByHandle;
		g_PidTobeProtct = read_kern_mem32.pid;//ҪPID
		g_Offsets.isSupported = read_kern_mem32.offset.isSupported;
		g_Offsets.KPROCESS = read_kern_mem32.offset.KPROCESS;
		g_Offsets.UniquePid = read_kern_mem32.offset.UniquePid;
		g_Offsets.ImgFileName = read_kern_mem32.offset.ImgFileName;

		dprintf("Hook ob");
		KphAcquireGuardedLock(&SsLock);
		HookStart();
		KphReleaseGuardedLock(&SsLock);
	}
	else if(read_kern_mem32.type == SYM_TYP_UNHOOK_OBR)
	{
		ptrdat = ObReferenceObjectByHandle;
		dprintf("Unhook ob");
		HookStop();
	}

	if ( ptrdat != NULL)
		WriteUserMode( read_kern_mem32.dst_address, read_kern_mem32.size, ptrdat );


	Irp->IoStatus.Status = STATUS_SUCCESS;
	status = Irp->IoStatus.Status;

	IoCompleteRequest(Irp, IO_NO_INCREMENT);
	return status;








/*
	irpSp = IoGetCurrentIrpStackLocation(Irp);

	switch(irpSp->Parameters.DeviceIoControl.IoControlCode)
	{
	case LIFED_IOCTL_CHANGE_MODE:
		DbgPrint("IoControlCode: LIFED_IOCTL_CHANGE_MODE...\n");
		if( irpSp->Parameters.DeviceIoControl.InputBufferLength != sizeof(READ_KERN_MEM_t))
			break;

		read_kern_mem =  * ( (READ_KERN_MEM_t *) Irp->AssociatedIrp.SystemBuffer );

		switch( read_kern_mem.type)
		{
		case SYM_TYP_KPCR:
// 			__asm
// 			{
// 				MOV EAX, FS:[0x1C] 
// 				MOV ptrdat, EAX 
// 			}
// 			DbgPrint( " FS0: 0x%08X\n", ptrdat );
			break;

		case SYM_TYP_MM_USR_PRB_ADDR:
			ptrdat = & MmUserProbeAddress;
			DbgPrint( " MmUserProbeAddress 0x%08X\n", MmUserProbeAddress  );
			break;

		case SYM_TYP_NULL:
			ptrdat = read_kern_mem.src_address;
			break;

		case SYM_TYP_PSLOUPRBYID:
			status = PsLookupProcessByProcessId( (HANDLE) read_kern_mem.src_address, &eprocess);
			ptrdat = &eprocess;
			if(status != STATUS_SUCCESS)
				eprocess = NULL;
			break;

		case SYM_TYP_HOOK_OBR:
			ptrdat = ObReferenceObjectByHandle;
			g_PidTobeProtct = read_kern_mem.pid;//ҪPID
			g_Offsets.isSupported = read_kern_mem.offset.isSupported;
			g_Offsets.KPROCESS = read_kern_mem.offset.KPROCESS;
			g_Offsets.UniquePid = read_kern_mem.offset.UniquePid;
			g_Offsets.ImgFileName = read_kern_mem.offset.ImgFileName;
			DbgPrint("Offset value: %x %x %x\n",g_Offsets.UniquePid,g_Offsets.KPROCESS,g_Offsets.ImgFileName);
			DbgPrint( " HookObReferenceObjectByHandle !\n" );
		//	HookObReferenceObjectByHandle();
		//	_asm int 3;
			KphAcquireGuardedLock(&SsLock);
			HookStart();
			KphReleaseGuardedLock(&SsLock);
			break;

		case SYM_TYP_UNHOOK_OBR:
			ptrdat = ObReferenceObjectByHandle;
			DbgPrint( " UNHookObReferenceObjectByHandle !\n" );
		//	UnHookObReferenceObjectByHandle();
			HookStop();
			break;

		case SYM_TYP_READWITHSTACKATTACH:
			DbgPrint("dst_addr:%08x\n",read_kern_mem.dst_address);
			DbgPrint("src_addr:%08x\n",read_kern_mem.src_address);
			DbgPrint("size:%08x\n",read_kern_mem.size);
			DbgPrint("other_info:%08x\n",read_kern_mem.other_info);
			DbgPrint("Pid:%d\n",read_kern_mem.pid);

			attr.Length = sizeof(OBJECT_ATTRIBUTES);   
			attr.RootDirectory = 0;   
			attr.ObjectName = 0;   
			attr.Attributes = 0;   
			attr.SecurityDescriptor = 0;   
			attr.SecurityQualityOfService = 0;   

			cid.UniqueProcess = (HANDLE)read_kern_mem.pid;   
			cid.UniqueThread = 0;   
			ZwOpenProcess(&ph, PROCESS_ALL_ACCESS, &attr, &cid);   

			status = KpiReadVirtualMemory(ph,
				read_kern_mem.src_address,
				read_kern_mem.dst_address,
				read_kern_mem.size,
				NumberOfBytesRead,
				accessMode);
			DbgPrint("status = %08x NumberOfBytesRead: %d\n",status,NumberOfBytesRead);
			/*
			memset(&apcState, 0, sizeof(KAPC_STATE));
			ptrdat = ExAllocatePoolWithTag(NonPagedPool, read_kern_mem.size, LIFEDEFNSE_TAG);
			if(ptrdat == NULL)
			break;
			KeStackAttachProcess((PRKPROCESS)read_kern_mem.other_info, &apcState);
			memcpy(read_kern_mem.dst_address, read_kern_mem.src_address, read_kern_mem.size);
			KeUnstackDetachProcess(&apcState);
			WriteUserMode(read_kern_mem.dst_address, read_kern_mem.size, read_kern_mem.src_address);
			ExFreePoolWithTag(ptrdat, LIFEDEFNSE_TAG);
			
			ptrdat = NULL;
			break;

		case SYM_TYP_WRITEUSERMEM:
			attr.Length = sizeof(OBJECT_ATTRIBUTES);   
			attr.RootDirectory = 0;   
			attr.ObjectName = 0;   
			attr.Attributes = 0;   
			attr.SecurityDescriptor = 0;   
			attr.SecurityQualityOfService = 0;   

			cid.UniqueProcess = (HANDLE)read_kern_mem.pid;   
			cid.UniqueThread = 0;   
			ZwOpenProcess(&ph, PROCESS_ALL_ACCESS, &attr, &cid);   

			status = KpiWriteVirtualMemory(ph,
				read_kern_mem.dst_address,
				read_kern_mem.src_address,
				read_kern_mem.size,
				NumberOfBytesRead,
				accessMode);
			DbgPrint("status = %08x NumberOfBytesRead: %d\n",status,NumberOfBytesRead);
			ptrdat = NULL;
			break;

		case SYM_TYP_GET_DATA:
			DbgPrint("CASE: SYM_TYP_GET_DATA ");
			pDataCount = read_kern_mem.process_count;
			if( MmIsAddressValid(pDataCount))
			{
				DbgPrint("SYM_TYP_GET_DATA get it!");
				pDataCount->dataCount = ScanAndGetProcessCount();
			}
			break;
		
		case SYM_TYP_GETPROC:
			// бƵûռ
			#define VALIDATE_LIST_BUFF_SIZE( totalBuffSize, dataType, listType ) ( ( totalBuffSize / sizeof( dataType ) ) <= GetListCount( listType ) )

			pArkProcData = Irp->AssociatedIrp.SystemBuffer;
			if( MmIsAddressValid( pArkProcData ) && VALIDATE_LIST_BUFF_SIZE( dwOutBuffSize, FLPROCESS_t, eProcList ) )
			{
				PPROCLISTENTRY pProcListEntry = NULL;
				while( STATUS_SUCCESS == GetListEntry( eProcList, nIndex, &pProcListEntry ) )
				{
					if( MmIsAddressValid( pProcListEntry ) )
					{
						pArkProcData[nIndex].procId = pProcListEntry->dwPID;
						RtlStringCchCopyA( pArkProcData[nIndex].procName, MAX_PATH, pProcListEntry->szProcName );
						++nIndex;
					}
					else
					{
						break;
					}
				}

				if( nIndex > 0 )
				{
					status = STATUS_SUCCESS;
					Irp->IoStatus.Information = dwOutBuffSize;
				}
			}
			// ͷŽб
			DelList( eProcList );
			break;


		default:
			ptrdat = NULL;
			break;

		}

		if ( ptrdat != NULL)
			WriteUserMode( read_kern_mem.dst_address, read_kern_mem.size, ptrdat );
		Irp->IoStatus.Status = STATUS_SUCCESS;

		break;

	default:
		Irp->IoStatus.Status = STATUS_INVALID_DEVICE_REQUEST;
		Irp->IoStatus.Information = 0;
		break;
	}

	status = Irp->IoStatus.Status;
	IoCompleteRequest(Irp, IO_NO_INCREMENT);
	return status;
	*/
}
