#include "HookDrv.h"
#include "hook.h"
#include "Utils.h"




// #define _ANSISTRING(text) #text
// #define ANSISTRING(text) _ANSISTRING(text)
// 
// #define _WIDESTRING(text) L##text
// #define WIDESTRING(text) _WIDESTRING(text)
// 
// #define PRESET_UNICODE_STRING(symbol, buffer) \
// 	UNICODE_STRING symbol = \
// 			{ \
// 			sizeof(WIDESTRING(buffer)) - sizeof(WCHAR), \
// 			sizeof(WIDESTRING(buffer)), \
// 			WIDESTRING(buffer) \
// 			};
#define DbgPrint(...) DbgPrintEx(DPFLTR_IHVDRIVER_ID, 0xffffffff, __VA_ARGS__)

//PRESET_UNICODE_STRING(DeviceName, DEVICE_NAME);
//PRESET_UNICODE_STRING(Win32Device, SYMLINK_NAME);



#ifdef ALLOC_PRAGMA
#pragma alloc_text(PAGE, DriverEntry)
#pragma alloc_text(PAGE, HookDrvUnload)
#pragma alloc_text(PAGE, HookDrvDefaultHandler)
#pragma alloc_text(PAGE, HookDrvCreateClose)
#pragma alloc_text(PAGE, HookDrvDefaultHandler)
#pragma alloc_text(PAGE, FLDispatchDeviceControl)
#endif








NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject, 
					 IN PUNICODE_STRING  RegistryPath)
{
	
	NTSTATUS status;
	UNICODE_STRING deviceName;
	UNICODE_STRING Win32Device;
	PDEVICE_OBJECT DeviceObject = NULL;

	unsigned i;

	/* ʼƫ */
	InitGlobals();

	/* Initialize hooking. */
	status = KphHookInit();

	status = HookInit();


	for (i = 0; i <= IRP_MJ_MAXIMUM_FUNCTION; i++)
		DriverObject->MajorFunction[i] = HookDrvDefaultHandler;

	DriverObject->MajorFunction[IRP_MJ_CREATE] = 
	DriverObject->MajorFunction[IRP_MJ_CLOSE] = HookDrvCreateClose;
	DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = FLDispatchDeviceControl;
	DriverObject->DriverUnload = HookDrvUnload;

	RtlInitUnicodeString(&deviceName, DEVICE_NAME);
	RtlInitUnicodeString(&Win32Device, SYMLINK_NAME);


	status = IoCreateDevice(DriverObject,
							0,
							&deviceName,
							FILE_DEVICE_UNKNOWN,
							0,
							FALSE,
							&DeviceObject);
	if (!NT_SUCCESS(status))
		return status;
	if (!DeviceObject)
		return STATUS_UNEXPECTED_IO_ERROR;

	DeviceObject->Flags |= DO_DIRECT_IO;
	DeviceObject->AlignmentRequirement = FILE_WORD_ALIGNMENT;
	status = IoCreateSymbolicLink(&Win32Device, &deviceName);

	DeviceObject->Flags &= ~DO_DEVICE_INITIALIZING;
	
	return status;
}


void HookDrvUnload(IN PDRIVER_OBJECT DriverObject)
{
	UNICODE_STRING Win32Device;
	RtlInitUnicodeString(&Win32Device, SYMLINK_NAME);
	IoDeleteSymbolicLink(&Win32Device);

	IoDeleteDevice(DriverObject->DeviceObject);
}

NTSTATUS HookDrvCreateClose(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp)
{
	DbgPrint( "Client (PID %Iu) is connecting\n", PsGetCurrentProcessId());
	Irp->IoStatus.Status = STATUS_SUCCESS;
	Irp->IoStatus.Information = 0;
	IoCompleteRequest(Irp, IO_NO_INCREMENT);
	return STATUS_SUCCESS;
}

NTSTATUS HookDrvDefaultHandler(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp)
{
	Irp->IoStatus.Status = STATUS_NOT_SUPPORTED;
	Irp->IoStatus.Information = 0;
	IoCompleteRequest(Irp, IO_NO_INCREMENT);
	return Irp->IoStatus.Status;
}


