/*
* FLdefense
*
* Copyright (C) 2012-2013 
*
* This file is part of ģ.
* ɨ
*
*/
#include "stdafx.h"
#include "ps.h"

//ȫֱ
extern OS_SPEC_DATA g_globalData;

int GetPid( PEPROCESS pEproc )
{
	int nPid = -1;
	__try
	{
		UNICODE_STRING usMethodName;
		PSGETPROCESSID pPsGetProcessId = NULL;
		if( MmIsAddressValid( pEproc ) )
		{
			// ʹ PsGetProcessId 
			RtlInitUnicodeString( &usMethodName, L"PsGetProcessId" );
			pPsGetProcessId = (PSGETPROCESSID)MmGetSystemRoutineAddress( &usMethodName );
			if( MmIsAddressValid( pPsGetProcessId ) )
			{
				nPid = (int)pPsGetProcessId( pEproc );
			}
			else
			{
				// Otherwise get pid manually
				//nPid = *( (int*)((DWORD)pEproc + g_globalData.dwPidOffset) );
			}
		}
	}
	__except( EXCEPTION_EXECUTE_HANDLER )
	{
		nPid = -1;
		DbgPrint( "Exception caught in GetPid()" );
	}
	return nPid;
}

NTSTATUS GetProcessName(PEPROCESS pEproc,char* szProcessImageName, UINT nStrLen )
{
	NTSTATUS retVal = STATUS_UNSUCCESSFUL;

	__try
	{
		UNICODE_STRING usMethodName;
		GET_PROCESS_IMAGE_NAME PsGetProcessImageFileName = NULL;
		if( MmIsAddressValid( pEproc ) )
		{
			// ʹ PsGetProcessImageFileName 
			RtlInitUnicodeString( &usMethodName, L"PsGetProcessImageFileName" );
			PsGetProcessImageFileName = (GET_PROCESS_IMAGE_NAME)MmGetSystemRoutineAddress( &usMethodName );
			if( MmIsAddressValid( PsGetProcessImageFileName ) )
			{
				char* pszImg = PsGetProcessImageFileName(pEproc);
				if(MmIsAddressValid(pszImg))
				{
					 RtlStringCchCopyA( szProcessImageName, nStrLen, pszImg );
					 retVal = STATUS_SUCCESS;
				}

			}
			else
			{
				return 0;
			}
		}

	}
	__except( EXCEPTION_EXECUTE_HANDLER)
	{
		retVal = STATUS_UNSUCCESSFUL;
		DbgPrint("exception caught in GetProcessName()");
	}

	return retVal;
}


/**
* ͨpidɨȡб
*
*
*/
NTSTATUS GetProcByPidScan()
{
	NTSTATUS retVal = STATUS_UNSUCCESSFUL;

	__try
	{
		int nPid = -1;
		DWORD dwPidIndex = 0;
		DWORD dwPrevPid = 0;
		PEPROCESS pEproc = NULL;
		PROCLISTENTRY procEntry;

		// пܵPID
		for( dwPidIndex = 0; dwPidIndex < FLDEFEN_NT_PROCESS_LIMIT; dwPidIndex++ )
		{
			// ȡEPROCESS
			pEproc = NULL;
			if( STATUS_SUCCESS == PsLookupProcessByProcessId( (HANDLE)dwPidIndex, &pEproc ) )
			{
				// Check if process is alive
			//	if( IsProcessAlive( pEproc ) )
				{
					// ̴ڲûбҵ
					nPid = GetPid( pEproc );
					if( ( nPid >= 0 ) && ( dwPrevPid != (DWORD)nPid ) )
					{
						// list
						RtlZeroMemory( &procEntry, sizeof( PROCLISTENTRY ) );
						dwPrevPid = (DWORD)nPid;
						procEntry.dwPID = dwPrevPid;
						GetProcessName( pEproc, procEntry.szProcName, MAX_PATH );
						retVal = AddListEntry( eProcList, &procEntry, TRUE );
						dprintf("Process name: %s\n",procEntry.szProcName);
					}
				}
				ObDereferenceObject( pEproc );
			}
		}
	}
	__except( EXCEPTION_EXECUTE_HANDLER)
	{
		retVal = STATUS_UNSUCCESSFUL;
		DbgPrint("Exception caught in GetProcByPidScan()");
	}

	return retVal;
}

/*
* @remarks: ϵͳ߳
*           ϵͳ߳еPreviousMode  KernelMode
*
*/
NTSTATUS ThreadSpooler( PVOID pvFuncAddr, PTHRPARAMS pThrParam )
{
	NTSTATUS retVal = STATUS_UNSUCCESSFUL;
	__try
	{
		HANDLE hThread = NULL;
		if( MmIsAddressValid( pvFuncAddr ) && MmIsAddressValid( pThrParam ) )
		{
			// Create a thread. Let the function execute in kernel mode context
			retVal = PsCreateSystemThread( &hThread,
				(ACCESS_MASK)0L,
				NULL, NULL, NULL,
				pvFuncAddr,
				(PVOID)pThrParam );
			if( STATUS_SUCCESS == retVal )
			{
				// Wait till thread completes
				retVal = ZwWaitForSingleObject( hThread, FALSE, NULL );

				// Set the return value based on thread's result
				if( STATUS_SUCCESS == retVal )
				{
					retVal = ( FALSE != pThrParam->bResult ) ? STATUS_SUCCESS : STATUS_UNSUCCESSFUL;
				}
				else
				{
#ifdef ARKITDRV_DEBUG_PRINT
					DbgPrint( "ThreadSpooler: ZwWaitForSingleObject failed: 0x%x", retVal );
#endif // ARKITDRV_DEBUG_PRINT
				}
				ZwClose( hThread );
			}
			else
			{
#ifdef ARKITDRV_DEBUG_PRINT
				DbgPrint( "ThreadSpooler: PsCreateSystemThread failed: 0x%x", retVal );
#endif // ARKITDRV_DEBUG_PRINT
			}
		}
	}
	__except( EXCEPTION_EXECUTE_HANDLER )
	{
		retVal = STATUS_UNSUCCESSFUL;
		DbgPrint( "Exception caught in ThreadSpooler()" );
	}
	return retVal;
}

/*
*
* ȡб
*
*/
VOID ScanAndGetProcessCountThread( PVOID pThrParam )
{
	__try
	{
		if( MmIsAddressValid( pThrParam ) )
		{
			// Initalize our internal process linked list where we store results
			if( STATUS_SUCCESS == InitList( eProcList ) )
			{

				// Scan by process id brute force
				DbgPrint("brute force scan pid...\n");
				GetProcByPidScan();

				// Set result to true if we have found any process
				((PTHRPARAMS)pThrParam)->bResult = !IsMyListEmpty( eProcList );
			}
		}
	}
	__except( EXCEPTION_EXECUTE_HANDLER )
	{
		DbgPrint( "Exception caught in ScanAndGetProcessCountThread()" );
	}
	PsTerminateSystemThread( STATUS_SUCCESS );
}

/*
* Wrapper to thread function to scan running processes
*
*/
UINT ScanAndGetProcessCount()
{
	UINT numProcs = 0;
	__try
	{
		// Create a thread to scan for processes
		THRPARAMS stThrParams = {0};
		if( STATUS_SUCCESS == ThreadSpooler( ScanAndGetProcessCountThread, &stThrParams ) )
		{
			numProcs = GetListCount( eProcList );
		}
	}
	__except( EXCEPTION_EXECUTE_HANDLER )
	{
		numProcs = 0;
		DbgPrint( "Exception caught in ScanAndGetProcessCount()" );
	}
	return numProcs;
}


/*
* ȡservices.exePid
*
*/
DWORD GetServicesPid()
{
	DWORD Pid = 0;
	UINT nCnt = 0;
	__try
	{
		// list
		PVOID pItem = NULL;
		while( STATUS_SUCCESS == GetListEntry( eProcList, nCnt, &pItem ) )
		{
			if( strcmp (((PPROCLISTENTRY)pItem)->szProcName , "services.exe") == 0)
			{
				Pid = ((PPROCLISTENTRY)pItem)->dwPID;
				break;
			}
// 			if( nCnt == 5)
// 			{
// 				Pid = ((PPROCLISTENTRY)pItem)->dwPID;
// 				break;
// 			}

			++nCnt;
		}
	}
	__except( EXCEPTION_EXECUTE_HANDLER )
	{
		Pid = -1;
		DbgPrint( "Exception caught in GetServicesPid()" );
	}

	return Pid;
}

/*
* ͨpebȡservices.exe Ļַ
*/
PVOID GetServicesBaseAddress(DWORD Pid)
{
	PVOID baseAddress = 0;
	__try
	{
		//ȡEprocess
		PEPROCESS pEproc = NULL;
		NTSTATUS retVal = PsLookupProcessByProcessId( (HANDLE)Pid, &pEproc);
		if( (STATUS_SUCCESS == retVal) && MmIsAddressValid( pEproc))
		{
			PKAPC_STATE pKapcState = ExAllocatePoolWithTag( NonPagedPool, sizeof( KAPC_STATE),LIFEDEFNSE_TAG);
			if( MmIsAddressValid(pKapcState))
			{
				PPEB pPeb = NULL;
				UNICODE_STRING usMethodName;
				PSGETPROCESSPB pPsGetProcessPeb = NULL;

				//ȡ PsGetProcessPebַ
				RtlInitUnicodeString( &usMethodName, L"PsGetProcessPeb");
				pPsGetProcessPeb = (PSGETPROCESSPB)MmGetSystemRoutineAddress( &usMethodName );

				//ȡý̵ Pebָ
				 pPeb = MmIsAddressValid( pPsGetProcessPeb ) ? pPsGetProcessPeb( pEproc ) : 0 ;

				 //ӵ̶ջ
				 KeStackAttachProcess( pEproc, pKapcState);

#if defined(_WIN64)
				 if( MmIsAddressValid(pPeb))
				 {
					PVOID PbaseAddress = (PBYTE)pPeb + g_globalData.dwPeb_BaseAddress;
					if( MmIsAddressValid(PbaseAddress))
						baseAddress =     ( (LONG64*)(*((LONG64*)(PbaseAddress))) );
				 }
#endif

				 //Detach ̶ջ
				 KeUnstackDetachProcess( pKapcState);

				 ExFreePool( pKapcState);
				 pKapcState = NULL;
			}
			// Dereference EPROCESS ָ
			ObDereferenceObject( pEproc );
		}

	}
	__except( EXCEPTION_EXECUTE_HANDLER )
	{
		baseAddress = -1;
		DbgPrint( "Exception caught in GetServicesBaseAddress()" );
	}
	return baseAddress;
}