#include "Drvctrl.h"

HANDLE g_hPort = INVALID_HANDLE_VALUE;
extern HANDLE g_device;
extern OFFSETS Offsets;

void * IOCTLReadKernMem( HANDLE device, READ_KERN_MEM_t * read_kern_mem )
{
	ULONG bytes_read ;

	bytes_read = 0 ;

	if
		( 
		DeviceIoControl
		( 
		device,
		LIFED_IOCTL_CHANGE_MODE,
		read_kern_mem,
		sizeof( * read_kern_mem ),
		NULL,
		0,
		& bytes_read,
		( LPOVERLAPPED) NULL
		)
		)
		return read_kern_mem->dst_address;

	return NULL;
}

/*
* ȡservices.exe 
* Pid
* Base Address
*/
DWORD GetProcessListByDrv( DWORD& pid, ULONGLONG& SerBase )
{
	DWORD Pid = 0;
	ULONGLONG ullServiceBase = 0;

	ULONG bytes_read ;

	bytes_read = 0 ;

	READ_KERN_MEM_t read_kern_m = {0};
	ARKDATACOUNT pro_count;
	read_kern_m.process_count = &pro_count;

	if(g_device == INVALID_HANDLE_VALUE)
	{
		return 0;
	}

	read_kern_m.type = SYM_TYP_GET_DATA;


	DeviceIoControl( 
		g_device,
		LIFED_IOCTL_CHANGE_MODE,
		&read_kern_m,
		sizeof(  read_kern_m ),
		NULL,
		0,
		& bytes_read,
		( LPOVERLAPPED) NULL
		);

	printf("Process count:%d ,Pid:%d, Services base:%I64X\n",read_kern_m.process_count->dataCount,read_kern_m.process_count->servicePid,read_kern_m.process_count->serviceBaseAddr);
	Pid = read_kern_m.process_count->servicePid;
	ullServiceBase = read_kern_m.process_count->serviceBaseAddr;
	
	pid = Pid;
	SerBase = ullServiceBase;

	return Pid;
}

/*
* ڶδʧ!!
*/
int LoadDriver( HANDLE * device)
{
	char* full_temp_path;
	SC_HANDLE handle_manager;
	SC_HANDLE handle_service;
	int returnf = FALSE;
	BOOL aux_return;
	DWORD last_error;
	SERVICE_STATUS service_status;

	int DRIVE2REALEASE;//Ҫͷŵ x64ͷ64λ

	if(Offsets.isX64)
		DRIVE2REALEASE = IDR_LIFE_DEFENSEX64;
	else
		DRIVE2REALEASE = IDR_LIFE_DEFENSE;

	*device = NULL;

	if(GetFullTempPath( &full_temp_path,DRIVER_NAME))
	{
		printf( "%s\n", full_temp_path );
		if(DumpRSRC(full_temp_path,DRIVE2REALEASE,"LIFE_DEFENSE"))
		{
			handle_manager = OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
			if(handle_manager != NULL)
			{
				handle_service = CreateServiceA(
					handle_manager,
					SERVICE_NAME,
					SERVICE_NAME,
					SERVICE_ALL_ACCESS,
					SERVICE_KERNEL_DRIVER,
					SERVICE_AUTO_START,
					SERVICE_ERROR_NORMAL,
					full_temp_path,
					NULL,
					NULL,
					NULL,
					NULL,
					NULL
					);

				last_error = GetLastError();
				if( (last_error == ERROR_SERVICE_EXISTS) || (last_error == ERROR_SERVICE_MARKED_FOR_DELETE))
				{//Ѿ´
					printf( "OK: ERROR_SERVICE_EXISTS / ERROR_SERVICE_MARKED_FOR_DELETE, Opening the service..\n" );

					handle_service = OpenServiceA(handle_manager,SERVICE_NAME,SERVICE_ALL_ACCESS);
					if( (last_error == ERROR_SERVICE_MARKED_FOR_DELETE) && (handle_service != NULL))
					{ //񱻱Ϊɾֹͣ´
						printf( "OK: ERROR_SERVICE_MARKED_FOR_DELETE, Stoping and recreating the service..\n" );

						ControlService(handle_service,SERVICE_CONTROL_STOP,&service_status);
						CloseServiceHandle(handle_service);

						handle_service = CreateServiceA(
							handle_manager,
							SERVICE_NAME,
							SERVICE_NAME,
							SERVICE_ALL_ACCESS,
							SERVICE_KERNEL_DRIVER,
							SERVICE_AUTO_START,
							SERVICE_ERROR_NORMAL,
							full_temp_path,
							NULL,
							NULL,
							NULL,
							NULL,
							NULL
							);
					}
				}
				if( handle_service != NULL)
				{
					aux_return = StartService( handle_service, 0, NULL );
					last_error  = GetLastError();
					if( (aux_return == TRUE) || (last_error == ERROR_SERVICE_ALREADY_RUNNING))
					{
						printf( "OK: Starting service\n " );

						* device = CreateFileA(
							NAMEOF_DEVICE,
							GENERIC_READ | GENERIC_WRITE,
							0, 
							NULL,
							OPEN_EXISTING,
							0,
							NULL
							);

						if(*device != INVALID_HANDLE_VALUE)
						{
							printf( "OK: Get the handle to device: %s\n", NAMEOF_DEVICE );
							returnf = TRUE;
						}
						else
						{
							int err = GetLastError();
						//	if(GetLastError() == ERROR_ACCESS_DENIED)
							{
								FLDRV_ERROR("CreateFile device fail!");
								returnf = 0;
							}
						}
					}
					CloseServiceHandle(handle_service);
				}
				CloseServiceHandle(handle_manager);
			}
		}
		free(full_temp_path);
	}

	return returnf;
}

int UnloadDriver( HANDLE * device)
{
	SC_HANDLE handle_manager;
	SC_HANDLE handle_service;
	SERVICE_STATUS service_status; 
	BOOLEAN returnf = FALSE;
	BOOLEAN aux_return;
	DWORD last_error;

	CloseHandle( * device );
	device = 0;

	handle_manager = OpenSCManager( NULL, NULL, SC_MANAGER_ALL_ACCESS );

	if ( handle_manager != NULL )
	{
		handle_service = OpenServiceA( handle_manager, SERVICE_NAME, SERVICE_ALL_ACCESS );
		last_error = GetLastError();
		if ( last_error != ERROR_SERVICE_DOES_NOT_EXIST )
		{
			if ( handle_service != NULL )
			{
				aux_return = ControlService( handle_service, SERVICE_CONTROL_STOP, & service_status );
				last_error = GetLastError();
				if ( aux_return == TRUE || ( last_error == ERROR_SERVICE_NOT_ACTIVE ) )
				{
					aux_return = TRUE;//DeleteService( handle_service );
					last_error = GetLastError();
					if ( ( aux_return == TRUE ) || ( last_error == ERROR_SERVICE_MARKED_FOR_DELETE ) )
					{
						returnf = TRUE;
					}
					else
						fprintf( stderr, "Error: Deleting the service\n" );
				}
				else
					fprintf( stderr, "Error: Stopping the driver\n" );

				CloseServiceHandle( handle_service );
			}
		}
		else
		{
			returnf = TRUE;
			printf("Error: service does not exsit!\n");
		}
		CloseServiceHandle(handle_manager);
	}
	return returnf;
}



BOOL FLConnectDrv()
{
	if( g_device != INVALID_HANDLE_VALUE)
		return TRUE;
	g_device = CreateFileA(
		NAMEOF_DEVICE,
		GENERIC_READ | GENERIC_WRITE,
		0, 
		NULL,
		OPEN_EXISTING,
		0,
		NULL
		);

	if( g_device != INVALID_HANDLE_VALUE)
		return TRUE;

	return FALSE;
}

BOOL FLConnectEx(PCHAR DeviceName)
{
	SC_HANDLE scmHandle;
	SC_HANDLE serviceHandle;
	BOOLEAN started = FALSE;
	BOOLEAN created = FALSE;
	BOOL status;

	if(!DeviceName)
		DeviceName = SERVICE_NAME;

	//Դ豸
	 status = FLConnectDrv();

	if(status)
		return TRUE;

	//

	// 
	scmHandle = OpenSCManager(NULL,NULL,SC_MANAGER_CONNECT);

	if(scmHandle)
	{
		serviceHandle = OpenService(scmHandle, DeviceName, SERVICE_START);

		if(serviceHandle)
		{
			if (StartService(serviceHandle, 0, NULL))
				started = TRUE;

			CloseServiceHandle(serviceHandle);
		}

		CloseServiceHandle(scmHandle);
	}

	if (!started)
	{
		//õļ·

		char DriverFileName[MAX_PATH];
		GetModuleDir(GetModuleHandle(DLL_NAME),DriverFileName);
		strcat(DriverFileName,DRIVER_NAME);

		if(!DumpRSRC(DriverFileName,IDR_FLPROF,"LIFE_DEFENSE"))
			return FALSE;


		//

		scmHandle = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

		if( scmHandle)
		{
			serviceHandle = CreateService(
				scmHandle,
				DeviceName,
				DeviceName,
				SERVICE_ALL_ACCESS,
				SERVICE_KERNEL_DRIVER,
				SERVICE_DEMAND_START,
				SERVICE_ERROR_IGNORE,
				DriverFileName,
				NULL,
				NULL,
				NULL,
				NULL,
				""
				);

			if( serviceHandle)
			{
				created = TRUE;

				if( StartService(serviceHandle, 0, NULL))
					started = TRUE;
			}

			CloseServiceHandle(scmHandle);
		}
		
	}

	if (started)
	{
		// ٳԴ豸
		status = FLConnectDrv();
	}

	/*
	if (created)
	{
		// "Delete" the service. Since we (may) have a handle to
		// the device, the SCM will delete the service automatically
		// when it is stopped (upon reboot). If we don't have a
		// handle to the device, the service will get deleted immediately,
		// which is a good thing anyway.
		DeleteService(serviceHandle);
		CloseServiceHandle(serviceHandle);
	}
	*/

	return status;
}

/*
* װinfļ
*/
BOOL InstallDrvByInf( char* lpszDriverName)
{
	char    szDriverImagePath[MAX_PATH]; 
	char	szDriverInfPath[MAX_PATH];
	char	cmd[MAX_PATH];

	// minFilter
	if( InitialCommunicationPort() == S_OK)
		return TRUE;

	// 
	if( StartDriver(NPMINI_NAME) == TRUE)
	{
		//ٴ
		if( InitialCommunicationPort() == S_OK)
			return TRUE;
		
	}
	//õ·
	GetModuleDir(GetModuleHandle(DLL_NAME),szDriverImagePath);
	strcpy(szDriverInfPath,szDriverImagePath);
	strcat(szDriverImagePath,lpszDriverName);
	strcat(szDriverInfPath,INF_NAME);

	int DRIVE2REALEASE;//Ҫͷŵ x64ͷ64λ

	if(Offsets.isX64)
	{
		DRIVE2REALEASE = IDR_FLPROFX64;

	}
	else
		DRIVE2REALEASE = IDR_FLPROF;

	if(!DumpRSRC(szDriverImagePath,DRIVE2REALEASE,"LIFE_DEFENSE"))
		return FALSE;

	if(!DumpRSRC(szDriverInfPath,IDR_PROFINF,"LIFE_DEFENSE"))
		return FALSE;

	strcpy(cmd,"/c rundll32 syssetup,SetupInfObjectInstallAction DefaultInstall 128 ");
	strcat(cmd,szDriverInfPath);

	printf("%s %s\n%s\n",szDriverImagePath,szDriverInfPath,cmd);

	//
	// rundll32 װinf ļ
	//
//	ShellExecuteA(NULL, "open", "rundll32.exe", cmd, NULL, SW_SHOWNORMAL);
	STARTUPINFO startupInfo;
	PROCESS_INFORMATION processInfo;

	ZeroMemory( &startupInfo, sizeof(startupInfo) );
	startupInfo.cb = sizeof(startupInfo);
	startupInfo.dwFlags = STARTF_USESHOWWINDOW;
	ZeroMemory( &processInfo, sizeof(processInfo) );
	char cmdPath[MAX_PATH];
	if(GetSystemDirectory(cmdPath,MAX_PATH) == NULL)
	{
		FLDRV_ERROR("GetDirectory error");
		return FALSE;
	}
	strcat(cmdPath,"\\cmd.exe");

	if (CreateProcess(cmdPath, cmd, 0, 0, FALSE, 0, 0, 0, &startupInfo, &processInfo))
	{
		WaitForSingleObject( processInfo.hProcess, INFINITE );
	}
	else
	{
		printf("Error\n"); //just using this to see what shows and doesnt show...will change eventually.
	}
	CloseHandle( processInfo.hProcess );
	CloseHandle( processInfo.hThread );

	//
	// WoW64ҪرضʵϵͳĿ¼system32\Drivers sysļ
	//
	char szSystemDriverPath[MAX_PATH];
	PVOID OldValue = NULL;	
	typedef BOOL (WINAPI *PFN_Wow64DisableWow64FsRedirection) (PVOID*); 
	typedef BOOL (WINAPI *PFN_Wow64RevertWow64FsRedirection) (PVOID); 
	PFN_Wow64DisableWow64FsRedirection Wow64DisableWow64FsRedirection;
	PFN_Wow64RevertWow64FsRedirection Wow64RevertWow64FsRedirection;

	Wow64DisableWow64FsRedirection = (PFN_Wow64DisableWow64FsRedirection)GetProcAddress( GetModuleHandle("kernel32"),"Wow64DisableWow64FsRedirection"); 
	Wow64RevertWow64FsRedirection = (PFN_Wow64RevertWow64FsRedirection)GetProcAddress( GetModuleHandle("kernel32"),"Wow64RevertWow64FsRedirection"); 

	GetSystemDirectoryA(szSystemDriverPath,MAX_PATH);
	strcat(szSystemDriverPath,"\\drivers\\");
	strcat(szSystemDriverPath,lpszDriverName);

	if (NULL != (Wow64DisableWow64FsRedirection && Wow64RevertWow64FsRedirection ) )
	{ 

		//ȡWow64ض
		if( Wow64DisableWow64FsRedirection(&OldValue) ) 
		{

			printf("Copy %s to %s........\n",szDriverImagePath,szSystemDriverPath);
			if( CopyFile(szDriverImagePath,szSystemDriverPath,FALSE) == 0)
				FLDRV_ERROR("CopyFile failed.");

			//ָWow64ض
			if ( FALSE == Wow64RevertWow64FsRedirection(OldValue) )
			{
				FLDRV_ERROR("Failed to RevertWow64FsRedirection");
			}
		}
	}


	if( StartDriver(NPMINI_NAME))
	{
		if( InitialCommunicationPort() == S_OK)
			return TRUE;
	}
	else
		FLDRV_ERROR("Start MiniDriver failed.");


	return FALSE;
	
}

/*
* װٴ!!
*/
BOOL InstallDriver(const char* lpszDriverName, char* lpszDriverPath,const char* lpszAltitude)
{
	char    szTempStr[MAX_PATH];
	HKEY    hKey;
	DWORD    dwData;
	char    *szDriverImagePath;    

	if( NULL==lpszDriverName || NULL==lpszDriverPath )
	{
		return FALSE;
	}
	//õ·
//	GetFullPathName(lpszDriverPath, MAX_PATH, szDriverImagePath, NULL);
	GetFullTempPath(&szDriverImagePath,lpszDriverPath);
	printf(szDriverImagePath);

	if(!DumpRSRC(szDriverImagePath,IDR_FLPROF,"LIFE_DEFENSE"))
		return FALSE;

	SC_HANDLE hServiceMgr=NULL;// SCMľ
	SC_HANDLE hService=NULL;// NTķ

	//򿪷ƹ
	hServiceMgr = OpenSCManager( NULL, NULL, SC_MANAGER_ALL_ACCESS );
	if( hServiceMgr == NULL ) 
	{
		// OpenSCManagerʧ
		CloseServiceHandle(hServiceMgr);
		return FALSE;        
	}

	// OpenSCManagerɹ  

	//Ӧķ
	hService = CreateService( hServiceMgr,
		lpszDriverName,             // עе
		lpszDriverName,             // עDisplayName ֵ
		SERVICE_ALL_ACCESS,         // ķȨ
		SERVICE_FILE_SYSTEM_DRIVER, // ʾصķļϵͳ
		SERVICE_DEMAND_START,       // עStart ֵ
		SERVICE_ERROR_IGNORE,       // עErrorControl ֵ
		szDriverImagePath,          // עImagePath ֵ
		"FSFilter Activity Monitor",// עGroup ֵ
		NULL, 
		"FltMgr",                   // עDependOnService ֵ
		NULL, 
		NULL);

	free(szDriverImagePath);

	if( hService == NULL ) 
	{        
		if( GetLastError() == ERROR_SERVICE_EXISTS ) 
		{
			//񴴽ʧܣڷѾ
			CloseServiceHandle(hService);       // 
			CloseServiceHandle(hServiceMgr);    // SCM
			return TRUE; 
		}
		else 
		{
			CloseServiceHandle(hService);       // 
			CloseServiceHandle(hServiceMgr);    // SCM
			return FALSE;
		}
	}
	CloseServiceHandle(hService);       // 
	CloseServiceHandle(hServiceMgr);    // SCM

	//-------------------------------------------------------------------------------------------------------
	// SYSTEM\\CurrentControlSet\\Services\\DriverName\\Instancesӽµļֵ 
	//-------------------------------------------------------------------------------------------------------
	strcpy(szTempStr,"SYSTEM\\CurrentControlSet\\Services\\");
	strcat(szTempStr,lpszDriverName);
	strcat(szTempStr,"\\Instances");
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,szTempStr,0,"",TRUE,KEY_ALL_ACCESS,NULL,&hKey,(LPDWORD)&dwData)!=ERROR_SUCCESS)
	{
		return FALSE;
	}
	// עDefaultInstance ֵ 
	strcpy(szTempStr,lpszDriverName);
	strcat(szTempStr," Instance");
	if(RegSetValueEx(hKey,"DefaultInstance",0,REG_SZ,(CONST BYTE*)szTempStr,(DWORD)strlen(szTempStr))!=ERROR_SUCCESS)
	{
		return FALSE;
	}
	RegFlushKey(hKey);//ˢע
	RegCloseKey(hKey);
	//-------------------------------------------------------------------------------------------------------

	//-------------------------------------------------------------------------------------------------------
	// SYSTEM\\CurrentControlSet\\Services\\DriverName\\Instances\\DriverName Instanceӽµļֵ 
	//-------------------------------------------------------------------------------------------------------
	strcpy(szTempStr,"SYSTEM\\CurrentControlSet\\Services\\");
	strcat(szTempStr,lpszDriverName);
	strcat(szTempStr,"\\Instances\\");
	strcat(szTempStr,lpszDriverName);
	strcat(szTempStr," Instance");
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,szTempStr,0,"",TRUE,KEY_ALL_ACCESS,NULL,&hKey,(LPDWORD)&dwData)!=ERROR_SUCCESS)
	{
		return FALSE;
	}
	// עAltitude ֵ
	strcpy(szTempStr,lpszAltitude);
	if(RegSetValueEx(hKey,"Altitude",0,REG_SZ,(CONST BYTE*)szTempStr,(DWORD)strlen(szTempStr))!=ERROR_SUCCESS)
	{
		return FALSE;
	}
	// עFlags ֵ
	dwData=0x0;
	if(RegSetValueEx(hKey,"Flags",0,REG_DWORD,(CONST BYTE*)&dwData,sizeof(DWORD))!=ERROR_SUCCESS)
	{
		return FALSE;
	}
	RegFlushKey(hKey);//ˢע
	RegCloseKey(hKey);
	//-------------------------------------------------------------------------------------------------------

	return TRUE;
}



BOOL StartDriver(const char* lpszDriverName)
{
	SC_HANDLE        schManager;
	SC_HANDLE        schService;
//	SERVICE_STATUS    svcStatus;

	if(NULL==lpszDriverName)
	{
		return FALSE;
	}

	schManager=OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
	if(NULL==schManager)
	{
		CloseServiceHandle(schManager);
		return FALSE;
	}
	schService=OpenService(schManager,lpszDriverName,SERVICE_ALL_ACCESS);
	if(NULL==schService)
	{
		CloseServiceHandle(schService);
		CloseServiceHandle(schManager);
		return FALSE;
	}

	if(!StartService(schService,0,NULL))
	{
		CloseServiceHandle(schService);
		CloseServiceHandle(schManager);
		if( GetLastError() == ERROR_SERVICE_ALREADY_RUNNING ) 
		{             
			// Ѿ
			return TRUE;
		} 
		return FALSE;
	}

	CloseServiceHandle(schService);
	CloseServiceHandle(schManager);

	return TRUE;
}

BOOL StopDriver(const char* lpszDriverName)
{
	SC_HANDLE        schManager;
	SC_HANDLE        schService;
	SERVICE_STATUS    svcStatus;
	bool            bStopped=false;

	schManager=OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
	if(NULL==schManager)
	{
		return FALSE;
	}
	schService=OpenService(schManager,lpszDriverName,SERVICE_ALL_ACCESS);
	if(NULL==schService)
	{
		CloseServiceHandle(schManager);
		return FALSE;
	}    
	if(!ControlService(schService,SERVICE_CONTROL_STOP,&svcStatus) && (svcStatus.dwCurrentState!=SERVICE_STOPPED))
	{
		CloseServiceHandle(schService);
		CloseServiceHandle(schManager);
		return FALSE;
	}

	CloseServiceHandle(schService);
	CloseServiceHandle(schManager);

	return TRUE;
}

BOOL DeleteDriver(const char* lpszDriverName)
{
	SC_HANDLE        schManager;
	SC_HANDLE        schService;
	SERVICE_STATUS    svcStatus;

	schManager=OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
	if(NULL==schManager)
	{
		return FALSE;
	}
	schService=OpenService(schManager,lpszDriverName,SERVICE_ALL_ACCESS);
	if(NULL==schService)
	{
		CloseServiceHandle(schManager);
		return FALSE;
	}
	ControlService(schService,SERVICE_CONTROL_STOP,&svcStatus);
	if(!DeleteService(schService))
	{
		CloseServiceHandle(schService);
		CloseServiceHandle(schManager);
		return FALSE;
	}
	CloseServiceHandle(schService);
	CloseServiceHandle(schManager);

	return TRUE;
}

/************************************************************************/
/* miniFilter ͨѶ                                                      */
/************************************************************************/


int InitialCommunicationPort(void)
{
	//ȳԹرվ
	//ڶӻʧ ʧܺٹؾҲ޷ 
	//

	if( CloseHandle(g_hPort))
		printf("CloseHandle sucess!\n");

	DWORD hResult = FilterConnectCommunicationPort( 
		NPMINI_PORT_NAME, 
		0, 
		NULL, 
		0, 
		NULL, 
		&g_hPort );

	if (hResult != S_OK) {
		FLDRV_ERROR("FilterConnectCommunicationPort Failed!");
		return hResult;
	}
	return 0;
}

int FLSendMessage(PVOID InputBuffer)
{
	DWORD bytesReturned = 0;
	DWORD hResult = 0;
	PCOMMAND_MESSAGE commandMessage = (PCOMMAND_MESSAGE) InputBuffer;	

	hResult = FilterSendMessage(
		g_hPort,
		commandMessage,
		sizeof(COMMAND_MESSAGE),
		NULL,
		NULL,
		&bytesReturned );

	if (hResult != S_OK) {
		return hResult;
	}
	return 0;
}