#include "Misc.h"

ZWQUERYINFORMATIONPROCESS_t ZwQueryInformationProcess;
ZWQUERYSYSTEMINFORMATION_t ZwQuerySystemInformation;
OFFSETS Offsets;

BOOL Init2UndocApi()
{
	ZwQueryInformationProcess = (ZWQUERYINFORMATIONPROCESS_t) \
		GetProcAddress( GetModuleHandleA( "ntdll.dll" ), "ZwQueryInformationProcess" );

	if ( ZwQueryInformationProcess == NULL )
	{
		fprintf( stderr, " Error: Getting ZwQueryInformationProcess from ntdll\n" );
		return FALSE;
	}


	ZwQuerySystemInformation = (ZWQUERYSYSTEMINFORMATION_t) \
		GetProcAddress(GetModuleHandleA("ntdll.dll"), "ZwQuerySystemInformation");

	if(ZwQuerySystemInformation == NULL)
	{
		fprintf(stderr, "Error: Getting ZwQuerySystemInformation from ntdll\n");
		return FALSE;
	}


	return TRUE;
}

/**
* 
* 
* @retval 1 ûбHOOK
* @retval 0	ѾHOOK
* @retval -1 HOOK!
*/
int DisasmInspectBuffer(char* buffer)
{
	DISASSEMBLY asmcode_1;	//
	DISASSEMBLY asmcode_2;	//
	DISASSEMBLY asmcode_3;	//
	DWORD index=0;

	ZeroMemory(&asmcode_1,sizeof(DISASSEMBLY));
	ZeroMemory(&asmcode_2,sizeof(DISASSEMBLY));
	ZeroMemory(&asmcode_3,sizeof(DISASSEMBLY));
	Decode(&asmcode_1,buffer,&index);
	index++;
	Decode(&asmcode_2,buffer,&index);
	index++;
	Decode(&asmcode_3,buffer,&index);


	printf(asmcode_1.Assembly);
	printf("\n");
	printf(asmcode_2.Assembly);
	printf("\n");
	printf(asmcode_3.Assembly);
	printf("\n");

	/*
	ԱȲѾhook
	 8bff            mov     edi,edi	//hot-patch point
	 55              push    ebp
	 8bec            mov     ebp,esp
	*/

	if( strcmp(asmcode_1.Opcode , "8BFF")+ \
		strcmp(asmcode_2.Opcode , "55")+\
		strcmp(asmcode_3.Opcode , "8BEC") == 0)
	{
		printf("----------Normal----------\n");
		return 1;
	}
	return 0;
}

void hexdump(char* buf, int dlen)
{
	char c[16+1];
	int i, ct;

	if (dlen < 0) {

		printf("WARNING: computed dlen %d\n", dlen);

		dlen = 0;

	}

	for (i=0; i<dlen; ++i) {

		if (i == 0)

			printf("DATA: ", c);

		else if ((i % 16) == 0) {

			c[16] = '\0';

			printf("\t\"%s\"\nDATA: ", c);

		}

		ct = buf[i] & 0xff;

		c[i % 16] = (ct >= ' ' && ct <= '~') ? ct : '.';

		printf("%02x ", ct);

	}

	c[i%16] = '\0';

	for (; i % 16; ++i)

		printf("   ");

	printf("\t\"%s\"\n", c);

}

unsigned int read4_little_endian(unsigned char *cp) {
	return (unsigned int)(cp[0])
		+ ((unsigned int)(cp[1]) << 8)
		+ ((unsigned int)(cp[2]) << 16)
		+ ((unsigned int)(cp[3]) << 24);
}

ULONGLONG read8_little_endian(unsigned char* cp)
{
	return (ULONGLONG)(cp[0]) 
		+ ((ULONGLONG)(cp[1]) << 8)
		+ ((ULONGLONG)(cp[2]) << 16)
		+ ((ULONGLONG)(cp[3]) << 24)
		+ ((ULONGLONG)(cp[4]) << 32)
		+ ((ULONGLONG)(cp[5]) << 40)
		+ ((ULONGLONG)(cp[6]) << 48)
		+ ((ULONGLONG)(cp[7]) << 56);
}

void CheckOSVersion()
{
	DWORD dwMajorVersion = 0;
	DWORD dwMinorVersion = 0; 
	DWORD dwVersion;

	Offsets.isSupported = TRUE;

	if(IsWow64())
	{
		printf("----------------inWow64 its a x64 system--------------------\n");
		Offsets.isX64 = TRUE;
	}
	else
	{
		printf("----------------its in x86--------------------\n");
		Offsets.isX64 = FALSE;
	}

	dwVersion = GetVersion();

	dwMajorVersion = (DWORD) ( LOBYTE( LOWORD( dwVersion ) ) );
	dwMinorVersion = (DWORD) ( HIBYTE( LOWORD( dwVersion ) ) );

	switch ( dwMajorVersion)
	{
	case 5:
		//printf("OS=2000, XP, Server 2003\n");
		switch (dwMinorVersion)
		{
		case 1:
			printf("XP\n");
			Offsets.KPROCESS = 0x44;
			Offsets.UniquePid = 0x84;
			Offsets.ImgFileName = 0x174;

			Offsets.ServiceDatabase = 0x04;
			Offsets.Acept_Name = 0x44;


		break;

		case 2:
			printf("Server 2003 (XP-X64)\n");
			Offsets.KPROCESS = 0x38;
			Offsets.UniquePid = 0x94;
			Offsets.ImgFileName = 0x164;

			Offsets.ServiceDatabase = 0x04;
			Offsets.Acept_Name = 0x4c;

			if(Offsets.isX64)
			{
				Offsets.ServiceDatabase = 0x08;
				Offsets.Acept_Name = 0x68;
				Offsets.DataOffset = 0xf0;
			}

		break;
		}

	break;

	case 6:
		switch (dwMinorVersion)
		{
		case 0:
			printf("OS=Vista, Server 2008\n");
			Offsets.KPROCESS = 0x48;
			Offsets.UniquePid = 0x9c;
			Offsets.ImgFileName = 0x14c;

			Offsets.ServiceDatabase = 0x60;
			Offsets.Acept_Name = 0x5c;

			if( Offsets.isX64)
			{
				Offsets.ServiceDatabase = 0x80;
				Offsets.Acept_Name = 0x88;
				Offsets.DataOffset = 0x300;
			}
		break;

		case 1:
			printf("OS=7, Server 2008\n");
			Offsets.KPROCESS = 0x50;
			Offsets.UniquePid = 0xb4;
			Offsets.ImgFileName = 0x16c;

			Offsets.ServiceDatabase = 0x60;
			Offsets.Acept_Name = 0x64;

			if(Offsets.isX64)
			{
				Offsets.ServiceDatabase = 0x80;
				Offsets.Acept_Name = 0x98;
				Offsets.DataOffset = 0x2c0;
			}
		break;

		default:
			Offsets.isSupported = FALSE;
			fprintf( stderr, " Error: KERNEL MinorVersion NOT SUPPORTED...\n" );
		break;
		}
	break;

	default:
		Offsets.isSupported = FALSE;
		fprintf( stderr, " Error: KERNEL MajorVersion NOT SUPPORTED...\n" );
	break;
	}

}

/**
 * жһǷ32λģģʽ
 *
 *
 */

NTSTATUS GetProcessIsWow64(
							 __in HANDLE ProcessHandle,
							 __out PBOOLEAN IsWow64
							 )
{
	NTSTATUS status;
	ULONG_PTR wow64;

	status = ZwQueryInformationProcess(
		ProcessHandle,
		ProcessWow64Information,
		&wow64,
		sizeof(ULONG_PTR),
		NULL
		);

	if (NT_SUCCESS(status))
	{
		*IsWow64 = !!wow64;
	}

	return status;
}

BOOL IsWow64() 
{ 
	typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS) (HANDLE, PBOOL); 
	LPFN_ISWOW64PROCESS fnIsWow64Process; 
	BOOL bIsWow64 = FALSE; 
	fnIsWow64Process = (LPFN_ISWOW64PROCESS)GetProcAddress( GetModuleHandle("kernel32"),"IsWow64Process"); 
	if (NULL != fnIsWow64Process) 
	{ 
		fnIsWow64Process(GetCurrentProcess(),&bIsWow64);
	} 
	return bIsWow64; 
} 

BOOL DumpRSRC( char *full_temp_path, int resource_id, char *driver_name )
{
	HRSRC handle_rsrc;
	HGLOBAL handle_rsrc_load;
	PVOID rsrc_lock;
	DWORD size_of_rsrc;
	FILE *file;
	BOOL returnf = FALSE;

	HMODULE hDll = GetModuleHandleA("lifedll.dll");//dllеԴʹdllľ

	handle_rsrc = FindResourceA(hDll,MAKEINTRESOURCE(resource_id), driver_name);
	if(handle_rsrc != NULL)
	{
		handle_rsrc_load = LoadResource(hDll,handle_rsrc);

		if(handle_rsrc_load != NULL)
		{
			rsrc_lock = LockResource(handle_rsrc_load);
			if(rsrc_lock != NULL)
			{
				size_of_rsrc = SizeofResource(hDll,handle_rsrc);
				if(size_of_rsrc != 0)
				{
					file = fopen(full_temp_path, "wb");
					if(file != NULL)
					{
						if(fwrite(rsrc_lock,size_of_rsrc,1,file) == 1)
						{
							returnf = TRUE;
						}
						else
							printf("Error : Dumping the data\n");

						fclose(file);
					}
				}
			}
		}
	}

	return returnf;
}

VOID GetModuleDir(HMODULE hModule, char* pszDir)
{

	DWORD dwLength = GetModuleFileNameA(hModule, pszDir, MAX_PATH);
	for(; pszDir[dwLength] != '\\'; dwLength--)
		pszDir[dwLength] = '\0';
}

BOOL GetFullTempPath( char ** out_full_temp_path, char * name )
{  
	char full_temp_path[MAX_PATH];
	DWORD ret_val = 0;

	ret_val = GetTempPathA( MAX_PATH, full_temp_path ); 

	GetModuleDir(GetModuleHandle(DLL_NAME),full_temp_path);

	if ( ret_val > MAX_PATH || ( ret_val == 0 ) )
		return FALSE;

	if 
		( 
		( strlen( full_temp_path ) + strlen( name ) ) 
		>=
		sizeof( full_temp_path ) 
		)
		return FALSE;

	* out_full_temp_path = (char*)calloc( 1, sizeof( full_temp_path ) );
	if ( * out_full_temp_path == NULL )
		return FALSE;

	strcat( full_temp_path, name );

	memcpy( * out_full_temp_path, full_temp_path, sizeof( full_temp_path ) );

	return TRUE;
}