#include "Module.h"
#include "..\pelib\PeLib.h"
extern "C"
{
#include "pe.h"
};


extern ZWQUERYSYSTEMINFORMATION_t ZwQuerySystemInformation;

DWORD gDataVAdress = 0;
extern OFFSETS Offsets;

PSYSTEM_MODULE_INFORMATION GetModuleList()
{
	PSYSTEM_MODULE_INFORMATION pModuleList = NULL;
	NTSTATUS status = STATUS_SUCCESS;
	ULONG neededSize = 0;

	__try
	{
		ZwQuerySystemInformation(SystemModuleInformation,
			&neededSize,
			0,
			&neededSize
			);

		pModuleList = (PSYSTEM_MODULE_INFORMATION)malloc(neededSize);
		if(pModuleList == NULL)
		{
			return NULL;
		}

		status = ZwQuerySystemInformation(SystemModuleInformation,
			pModuleList,
			neededSize,
			0
			);

		if(!NT_SUCCESS(status))
		{
			free(pModuleList);
			pModuleList = NULL;
		}
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
		OARK_EXCEPTION();

	return pModuleList;
}

PSYSTEM_MODULE GetKernelModuleInformation()
{
	PSYSTEM_MODULE_INFORMATION pSysModuleList = NULL;
	PSYSTEM_MODULE pSysModule = NULL;

	pSysModuleList = GetModuleList();
	if(pSysModuleList)
	{
		if(pSysModuleList->ModulesCount)
		{
			pSysModule = (PSYSTEM_MODULE)malloc(sizeof(SYSTEM_MODULE));
			if(pSysModule)
			{
				memcpy(pSysModule, pSysModuleList->Modules, sizeof(SYSTEM_MODULE));
			}
		}
	}

	if(pSysModuleList!=NULL)
		free(pSysModuleList);

	return pSysModule;
	
}

HANDLE LoadKernInAddrSpace()
{
	PSYSTEM_MODULE pKernInfo = NULL;
	HANDLE hKern = NULL;

	pKernInfo = GetKernelModuleInformation();
	if(pKernInfo)
	{
		hKern = LoadLibraryA((char*)(pKernInfo->Name + pKernInfo->NameOffset));
		free(pKernInfo);
	}

	return hKern;
}

DWORD GetKernelExportFuncAddr(PCHAR pFuncName)
{
	DWORD pFuncAddr = NULL;
	PSYSTEM_MODULE pKernInfo = NULL;
	HMODULE pKern = NULL;

	__try
	{
		pKern = (HMODULE)LoadKernInAddrSpace();
		if(pKern == NULL)
		{
			FLDRV_ERROR("LoadKernInAddrSpace failed");
			goto clean;
		}

		pKernInfo = GetKernelModuleInformation();
		if(pKernInfo == NULL)
		{
			FLDRV_ERROR("GetKernelModuleInformation failed");
			goto clean;
		}

		pFuncAddr = (DWORD)GetExportedSymbol(pKern, pFuncName, FALSE);
		if(pFuncAddr == NULL)
		{
			FLDRV_ERROR("GetExportedSymbol failed");
			goto clean;
		}

		(DWORD)pFuncAddr += (DWORD)pKernInfo->ImageBaseAddress;

clean:
		if(pKern != NULL)
			FreeLibrary(pKern);

		if(pKernInfo != NULL)
			free(pKernInfo);
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
		OARK_EXCEPTION();

	printf("%s:%08x\n",pFuncName,pFuncAddr);
	return pFuncAddr;
}



DWORD GetBaseAddress(DWORD dwPID)
{
	HANDLE hModuleSnap = INVALID_HANDLE_VALUE;
	MODULEENTRY32 me32;
	// Take a snapshot of all modules in the specified process.
	hModuleSnap = CreateToolhelp32Snapshot( TH32CS_SNAPMODULE, dwPID );
	if( hModuleSnap == INVALID_HANDLE_VALUE )
	{
		FLDRV_ERROR("When Call CreateToolhelp32Snapshot return:Invalid handle value!");
		return 0;
	}
	// Set the size of the structure before using it.
	me32.dwSize = sizeof( MODULEENTRY32 );
	// Retrieve information about the first module,
	// and exit if unsuccessful
	if( !Module32First( hModuleSnap, &me32 ) )
	{
		CloseHandle( hModuleSnap );           // clean the snapshot object
		return 0;
	}
	DWORD Value = (DWORD)me32.modBaseAddr;
	CloseHandle( hModuleSnap );
	return Value;
}

/*
* õϵͳװķ
*/
int GetServiceCount()
{
	HKEY		hKey;						//main key
	LONG		result;						//result
	DWORD		index = 0;					//index
	DWORD		cb = 512, cbValue = 512;	//buffers sizes
	char		szValue[512];				//buffer

	result = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "System\\CurrentControlSet\\Services", 0, KEY_ALL_ACCESS, &hKey);
	if(result == ERROR_SUCCESS){
		//loop through values
		result = RegEnumKeyEx(hKey, index, szValue, &cb, NULL, NULL, NULL, NULL);
		while(result != ERROR_NO_MORE_ITEMS){
			//increase index
			index++;
			//loop
			result = RegEnumKeyEx(hKey, index, szValue, &cb, NULL, NULL, NULL, NULL);
		}
		//close main key
		RegCloseKey(hKey);
	}
	return index;
}


DWORD GetServiceDataBase( DWORD dwPID = NULL )
{
	DWORD SvcDatabase = NULL;

	// ˺õBaseAddress  LoadLibraryõĻַһ
	// Բٵô˺
	//
//	DWORD ServiceBase = GetBaseAddress(dwPID);

	HMODULE hServices = LoadLibraryA("services.exe");

	DWORD hCode = (DWORD)hServices + (DWORD)GetPEField(hServices,BASE_OF_CODE);

	/*
	*	 
	* neg eax
	* sbb eax,eax
	* neg eax
	* pop esi
	*/
	char byte_seq[7] = {0xF7, 0xD8, 0x1B, 0xC0, 0xF7, 0xD8, 0x5E};

	void* found = memmem((void*)hCode,0x10000,byte_seq,7);
	if(found == NULL)
	{
		FLDRV_ERROR("Can not found byte_seq.");
		return 0;
	}

	PDWORD pAddr = (PDWORD)((DWORD)found - 0x33); //-0x33 ָServiceDatabase
	SvcDatabase = (DWORD)(*pAddr);
	
	if(hServices)
		FreeLibrary(hServices);

	return SvcDatabase;
}

DWORD GetServiceDataBaseWoW64( ULONGLONG baseAddr, ULONGLONG& DatabaseAddr )
{
	DWORD retVal = NULL;
	char  szServicesPath[MAX_PATH];
	DWORD DataVA = NULL;//ݶַ

	PVOID OldValue = NULL;	

 	typedef BOOL (WINAPI *PFN_Wow64DisableWow64FsRedirection) (PVOID*); 
 	typedef BOOL (WINAPI *PFN_Wow64RevertWow64FsRedirection) (PVOID); 
 	PFN_Wow64DisableWow64FsRedirection Wow64DisableWow64FsRedirection;
 	PFN_Wow64RevertWow64FsRedirection Wow64RevertWow64FsRedirection;
 
 	Wow64DisableWow64FsRedirection = (PFN_Wow64DisableWow64FsRedirection)GetProcAddress( GetModuleHandle("kernel32"),"Wow64DisableWow64FsRedirection"); 
 	Wow64RevertWow64FsRedirection = (PFN_Wow64RevertWow64FsRedirection)GetProcAddress( GetModuleHandle("kernel32"),"Wow64RevertWow64FsRedirection"); 
 
 	GetSystemDirectoryA(szServicesPath,MAX_PATH);
 	strcat(szServicesPath,"\\services.exe");
 	printf("SCM PATH:%s\n",szServicesPath);
 
	if (NULL != (Wow64DisableWow64FsRedirection && Wow64RevertWow64FsRedirection ) )
	{ 

		//ȡWow64ض
		if( Wow64DisableWow64FsRedirection(&OldValue) ) 
		{
			//ȡ64λservice.exeݶַ
			GetTextVitualOffset(szServicesPath);
			DataVA = gDataVAdress;

			//SvcDatabase = DataVA + services.exeַ
			DatabaseAddr = DataVA + baseAddr + Offsets.DataOffset;
			printf("SvcDatabase:%I64X, DataVA:%08x\n", DatabaseAddr, DataVA);

/************************************************************************/
/*   mov     cs:?ServiceDatabase@@3U_SERVICE_RECORD@@A, rbx ; _SERVICE_RECORD ServiceDatabase*/
/*
/*   ServiceDatabase ȫֱͨλݶοͷ
/*   XP(64):	0x1000310f0 ,services.exeַ(0x100000000) + ݶVA(0x31000) + 0xf0
/*   WIN7(64):	0x1000482c0 ,services.exeַ(0x100000000) + ݶVA(0x48000) + 0x2c0
/*
/************************************************************************/



			//ָWow64ض
			if ( FALSE == Wow64RevertWow64FsRedirection(OldValue) )
			{
				FLDRV_ERROR("Failed to RevertWow64FsRedirection");
				retVal = 0;
			}
		}

	}


	return retVal;
}

/************************************************************************/
/* ȡPEļRVA ֧64λPE                                     */
/************************************************************************/
template<int bits>
void dumpPeHeader(PeLib::PeFile& pef)
{
	const PeLib::PeHeaderT<bits>& peh = static_cast<PeLib::PeFileT<bits>&>(pef).peHeader();

	unsigned __int64 imagebase = peh.getImageBase();
	int sectionAlign = peh.getSectionAlignment();

	for (unsigned int i=0;i<peh.getNumberOfRvaAndSizes();i++)
	{
		peh.getImageDataDirectoryRva(i);
		peh.getImageDataDirectorySize(i);
	}


	for (int i=0;i<peh.getNumberOfSections();i++)
	{
		std::string Secname = peh.getSectionName(i);
		if(Secname == ".data")
		{
			gDataVAdress = peh.getVirtualAddress(i);
		//	offset = peh.getPointerToRawData(i);
		//	sizeOfRaw = peh.getSizeOfRawData(i);
		}
		peh.getVirtualSize(i);
		peh.getVirtualAddress(i);
		peh.getSizeOfRawData(i);
		peh.getPointerToRawData(i);
		peh.getPointerToRelocations(i);
		peh.getPointerToLinenumbers(i);
		peh.getNumberOfRelocations(i);
		peh.getNumberOfLinenumbers(i);
		peh.getCharacteristics(i);
	}



}

class DumpPeHeaderVisitor : public PeLib::PeFileVisitor
{
public:
	virtual void callback(PeLib::PeFile32 &file) {dumpPeHeader<32>(file);}
	virtual void callback(PeLib::PeFile64 &file) {dumpPeHeader<64>(file);}
};

DWORD GetExportFuncRva(PCHAR pFileName,PCHAR pFuncName)
{
	DWORD addr = 0;
	PeLib::PeFile* pef = PeLib::openPeFile(pFileName);
	if( pef == NULL)
	{
		FLDRV_ERROR("Invalid pe file.");
		return 0;
	}

	pef->readMzHeader();
	pef->readPeHeader();

	DumpPeHeaderVisitor v1;
	pef->visit(v1);

	//
	if( pef->readExportDirectory() == NULL)
	{
		FLDRV_ERROR("No ExportDirectory.");
		delete pef;
		return 0;
	}

	//ȽϺ
	const PeLib::ExportDirectory& exp = pef->expDir();
	for (unsigned int i=0;i<exp.getNumberOfFunctions();i++)
	{
		std::string sName = exp.getFunctionName(i);
		if(sName == pFuncName)
		{
			addr = exp.getAddressOfFunction(i);
			break;
		}
		exp.getFunctionOrdinal(i);
		exp.getAddressOfFunction(i);

	}

	delete pef;

	return addr;
}

/*
* õPEļ.TEXTεƫ  ֧64λPE
*/
DWORD GetTextVitualOffset(PCHAR pFileName)
{
	PeLib::PeFile* pef = PeLib::openPeFile(pFileName);
	if( pef == NULL)
	{
		FLDRV_ERROR("Invalid pe file.");
		return 0;
	}

	pef->readMzHeader();
	pef->readPeHeader();

	DumpPeHeaderVisitor v1;
	pef->visit(v1);

	return 1;
}