#include "process.h"
#include "Drvctrl.h"

extern ZWQUERYSYSTEMINFORMATION_t ZwQuerySystemInformation;

PSYSTEM_PROCESS_INFORMATION GetProcessList()
{
	PSYSTEM_PROCESS_INFORMATION pProcessInfo = NULL;
	NTSTATUS state = 0;
	DWORD size = 0;

	__try
	{
		state = ZwQuerySystemInformation(SystemProcessInformation,
			NULL,
			0,
			&size
			);

		pProcessInfo = (PSYSTEM_PROCESS_INFORMATION)malloc(size);
		if(pProcessInfo == NULL)
		{
			FLDRV_ERROR("Can not get ProcessInfo");
			return NULL;
		}

		state = ZwQuerySystemInformation(SystemProcessInformation,
			pProcessInfo,
			size,
			&size
			);

		if(!NT_SUCCESS(state))
		{
			FLDRV_ERROR("ZwQuerySystemInformation failed");
			free(pProcessInfo);
			pProcessInfo = NULL;
		}
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
		OARK_EXCEPTION();

	return pProcessInfo;
}

PDWORD PID2Eprocess(HANDLE hDevice, DWORD pid)
{
	READ_KERN_MEM_t read_kern_m = {0};
	PDWORD pEprocess = NULL;

	__try
	{
		read_kern_m.dst_address = &pEprocess;
		read_kern_m.size = sizeof(DWORD);
		read_kern_m.type = SYM_TYP_PSLOUPRBYID;
		read_kern_m.src_address = (PVOID)pid;

		if(IOCTLReadKernMem(hDevice, &read_kern_m) == NULL)
			FLDRV_ERROR("IOCTRL_ERROR");
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
		OARK_EXCEPTION();

	return pEprocess;
}

DWORD GetPid(wchar_t* pName)
{
	PSYSTEM_PROCESS_INFORMATION pProcessInfos = NULL, pProcessInformation = NULL;
	DWORD PidServices = 0;

	pProcessInfos = GetProcessList();
	if(pProcessInfos == NULL)
	{
		FLDRV_ERROR("GetProcessList failed");
	}

	while(pProcessInfos->NextEntryOffset != 0)
	{
		if(pProcessInfos->ImageName.Buffer != NULL)
		{
			if(wcsicmp(pProcessInfos->ImageName.Buffer,pName) == 0)
			{
				PidServices = (DWORD)pProcessInfos->Threads[0].ClientId.UniqueProcess;
				break;
			}
		}
		pProcessInfos = (PSYSTEM_PROCESS_INFORMATION)((((DWORD)pProcessInfos) + pProcessInfos->NextEntryOffset));
	}

	return PidServices;
}