#ifndef __COMMON_H__
#define __COMMON_H__

#include <WinDef.h>

#define LIFEDEFNSE_VERSION	"0.0.1"
#define LIFEDEFNSE_TAG 'LIFD'

#define DEVICE_NAME			L"\\Device\\FLDEFEN"
#define SYMLINK_NAME		L"\\DosDevices\\FLDEFEN"

#define NAMEOF_DEVICE       "\\\\.\\FLDEFEN"
#define DRIVER_NAME         "FLDEFEN.SYS"
#define SERVICE_NAME        "FLDEFEN"

#define DLL_NAME			"LifeDll.dll"
#define INF_NAME			"flprof.inf"

#define LIFED_IOCTL_CHANGE_MODE \
	CTL_CODE( FILE_DEVICE_UNKNOWN,0x931,METHOD_OUT_DIRECT,FILE_READ_DATA|FILE_WRITE_DATA)

typedef enum MEM_SYM_TYP_e
{
	SYM_TYP_NULL = 0,
	SYM_TYP_KPCR,
	SYM_TYP_IDT,
	SYM_TYP_GDT,
	SYM_TYP_READ_MSR,    /*!< Read a Model Specific Register. */ 
	SYM_TYP_PSLOUTHBYID, /*!< Perform a call to PsLookupThreadByThreadId, TID -> ETHREAD. */  
	SYM_TYP_PSLOUPRBYID, /*!< Perform a call to PsLookupProcessByProcessId, PID -> EPROCESS */
	SYM_TYP_READWITHSTACKATTACH, /*!< Perform a memory read after a KeStackAttachProcess */
	SYM_TYP_WRITEUSERMEM,/*дûռڴ*/
	SYM_TYP_OBDEREFOBJ,
	SYM_TYP_MM_USR_PRB_ADDR,
	SYM_TYP_HOOK_OBR,
	SYM_TYP_UNHOOK_OBR,
	SYM_TYP_GET_DATA,
	SYM_TYP_GETPROC /*ȡб*/
} MEM_SYM_TYP_t;

//ͬϵͳµƫ
typedef struct _OFFSETS
{
	BOOLEAN isSupported;
	BOOLEAN isX64;

	//̱
	DWORD KPROCESS;
	DWORD UniquePid;
	DWORD ImgFileName;

	//񱣻
	DWORD ServiceDatabase;//service.exeServiceDatabaseƫ
	DWORD Acept_Name;	//Aceptcontrol ֵı
	DWORD DataOffset;	//ݶƫ  64λͨݶƫȡDatabase

} OFFSETS;


//û㶼ҪĽ̽ṹ
typedef struct FLPROCESS
{
	DWORD procId;
	char procName[MAX_PATH];
}FLPROCESS_t, *PFLPROCESS;

typedef struct _ARKDATACOUNT {
	DWORD servicePid;
	ULONGLONG serviceBaseAddr;
	UINT dataCount;
} ARKDATACOUNT, *PARKDATACOUNT;

typedef struct READ_KERN_MEM_s
{
	void           * src_address;
	DWORD            size;
	MEM_SYM_TYP_t    type;
	void           * dst_address;
	ULONGLONG		ll_address;
	void           * other_info;
	DWORD			pid;	//ҪPid
	PARKDATACOUNT    process_count;
	OFFSETS			offset;
} READ_KERN_MEM_t;

//win7  ṹ
// typedef struct _SERVICE_RECORD
// {
// 	_SERVICE_RECORD *pPrev;
// 	LPWSTR			ServerName;//
// 	LPWSTR			DisplayName;//ʾ
// 	DWORD			dwCount;	//
// 	DWORD			dwUnkown1[2];
// 	DWORD			dwSerType;
// 	LPWSTR			ServerPath;//·?
// 	DWORD			dwunkown2[2];
// 	DWORD			dwAcceptControl;//1: 0:
// 	DWORD			dwNoCare1[13];
// 	_SERVICE_RECORD *pNext;
// 	DWORD			dwNoCare2[17];
// 	
// }SERVICE_RECORD, *PSERVICE_RECORD;



#endif