/*
* PeHeader.cpp - Part of the PeLib library.
*
* Copyright (c) 2004 Sebastian Porst (webmaster@the-interweb.com)
* All rights reserved.
*
* This software is licensed under the zlib/libpng License.
* For more details see http://www.opensource.org/licenses/zlib-license.php
* or the license information file (license.htm) in the root directory 
* of PeLib.
*/

#include "PeLibInc.h"
#include "PeHeader.h"

namespace PeLib
{
	PeHeader::~PeHeader(){}
	
	/**
	* @return The BaseOfData value from the PE header.
	**/
	dword PeHeader32::getBaseOfData() const
	{
		return m_inthHeader.OptionalHeader.BaseOfData;
	}

	/**
	* Changes the file's BaseOfData.
	* @param dwValue New value.
	**/
	void PeHeader32::setBaseOfData(dword dwValue)
	{
		m_inthHeader.OptionalHeader.BaseOfData = dwValue;
	}

	void PeHeader32::readBaseOfData(InputBuffer& ibBuffer)
	{
		ibBuffer >> m_inthHeader.OptionalHeader.BaseOfData;
	}
	
	void PeHeader64::readBaseOfData(InputBuffer&)
	{
	}
	
	void PeHeader32::rebuildBaseOfData(OutputBuffer& obBuffer) const
	{
		obBuffer << m_inthHeader.OptionalHeader.BaseOfData;
	}
	
	void PeHeader64::rebuildBaseOfData(OutputBuffer&) const
	{
	}
	
    template<>
    bool PeHeaderT<32>::isValid(unsigned int pehf) const
    {
    /*
        if (pehf == NtSignature)
        {
            return m_inthHeader.Signature == IMAGE_NT_SIGNATURE;
        }
        else if (pehf == NumberOfSections)
        {
            return getNumberOfSections() == calcNumberOfSections();
        }      */
        return false;
    }

}
